<!DOCTYPE html><html lang="en"><head><meta charset="utf-8"><meta name="viewport" content="width=device-width, initial-scale=1.0"><meta name="generator" content="rustdoc"><meta name="description" content="Unpack a paragraph of already-wrapped text."><meta name="keywords" content="rust, rustlang, rust-lang, unfill"><title>unfill in textwrap - Rust</title><link rel="preload" as="font" type="font/woff2" crossorigin href="../SourceSerif4-Regular.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../FiraSans-Regular.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../FiraSans-Medium.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../SourceCodePro-Regular.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../SourceSerif4-Bold.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../SourceCodePro-Semibold.ttf.woff2"><link rel="stylesheet" type="text/css" href="../normalize.css"><link rel="stylesheet" type="text/css" href="../rustdoc.css" id="mainThemeStyle"><link rel="stylesheet" type="text/css" href="../ayu.css" disabled><link rel="stylesheet" type="text/css" href="../dark.css" disabled><link rel="stylesheet" type="text/css" href="../light.css" id="themeStyle"><script id="default-settings" ></script><script src="../storage.js"></script><script defer src="sidebar-items.js"></script><script defer src="../main.js"></script><noscript><link rel="stylesheet" href="../noscript.css"></noscript><link rel="alternate icon" type="image/png" href="../favicon-16x16.png"><link rel="alternate icon" type="image/png" href="../favicon-32x32.png"><link rel="icon" type="image/svg+xml" href="../favicon.svg"></head><body class="rustdoc fn"><!--[if lte IE 11]><div class="warning">This old browser is unsupported and will most likely display funky things.</div><![endif]--><nav class="mobile-topbar"><button class="sidebar-menu-toggle">&#9776;</button><a class="sidebar-logo" href="../textwrap/index.html"><div class="logo-container"><img class="rust-logo" src="../rust-logo.svg" alt="logo"></div>
        </a><h2 class="location"></h2>
    </nav>
    <nav class="sidebar"><a class="sidebar-logo" href="../textwrap/index.html"><div class="logo-container"><img class="rust-logo" src="../rust-logo.svg" alt="logo"></div>
        </a><div class="sidebar-elems"><h2 class="location"><a href="index.html">In textwrap</a></h2></div></nav><main><div class="width-limiter"><div class="sub-container"><a class="sub-logo-container" href="../textwrap/index.html"><img class="rust-logo" src="../rust-logo.svg" alt="logo"></a><nav class="sub"><form class="search-form"><div class="search-container"><span></span><input class="search-input" name="search" autocomplete="off" spellcheck="false" placeholder="Click or press ‘S’ to search, ‘?’ for more options…" type="search"><div id="help-button" title="help" tabindex="-1"><button type="button">?</button></div><div id="settings-menu" tabindex="-1">
                                <a href="../settings.html" title="settings"><img width="22" height="22" alt="Change settings" src="../wheel.svg"></a></div>
                        </div></form></nav></div><section id="main-content" class="content"><div class="main-heading">
    <h1 class="fqn"><span class="in-band">Function <a href="index.html">textwrap</a>::<wbr><a class="fn" href="#">unfill</a><button id="copy-path" onclick="copy_path(this)" title="Copy item path to clipboard"><img src="../clipboard.svg" width="19" height="18" alt="Copy item path"></button></span></h1><span class="out-of-band"><a class="srclink" href="../src/textwrap/lib.rs.html#625-664">source</a> · <a id="toggle-all-docs" href="javascript:void(0)" title="collapse all docs">[<span class="inner">&#x2212;</span>]</a></span></div><div class="docblock item-decl"><pre class="rust fn"><code>pub fn unfill(text: &amp;<a class="primitive" href="https://doc.rust-lang.org/nightly/std/primitive.str.html">str</a>) -&gt; (<a class="struct" href="https://doc.rust-lang.org/nightly/alloc/string/struct.String.html" title="struct alloc::string::String">String</a>, <a class="struct" href="struct.Options.html" title="struct textwrap::Options">Options</a>&lt;'_&gt;)</code></pre></div><details class="rustdoc-toggle top-doc" open><summary class="hideme"><span>Expand description</span></summary><div class="docblock"><p>Unpack a paragraph of already-wrapped text.</p>
<p>This function attempts to recover the original text from a single
paragraph of text produced by the <a href="fn.fill.html" title="fill"><code>fill</code></a> function. This means
that it turns</p>
<div class="example-wrap"><pre class="language-text"><code>textwrap: a small
library for
wrapping text.</code></pre></div>
<p>back into</p>
<div class="example-wrap"><pre class="language-text"><code>textwrap: a small library for wrapping text.</code></pre></div>
<p>In addition, it will recognize a common prefix among the lines.
The prefix of the first line is returned in
<a href="struct.Options.html#method.initial_indent" title="Options::initial_indent"><code>Options::initial_indent</code></a> and the prefix (if any) of the the
other lines is returned in <a href="struct.Options.html#method.subsequent_indent" title="Options::subsequent_indent"><code>Options::subsequent_indent</code></a>.</p>
<p>In addition to <code>' '</code>, the prefixes can consist of characters used
for unordered lists (<code>'-'</code>, <code>'+'</code>, and <code>'*'</code>) and block quotes
(<code>'&gt;'</code>) in Markdown as well as characters often used for inline
comments (<code>'#'</code> and <code>'/'</code>).</p>
<p>The text must come from a single wrapped paragraph. This means
that there can be no <code>&quot;\n\n&quot;</code> within the text.</p>
<h2 id="examples"><a href="#examples">Examples</a></h2>
<div class="example-wrap"><pre class="rust rust-example-rendered"><code><span class="kw">use</span> <span class="ident">textwrap::unfill</span>;

<span class="kw">let</span> (<span class="ident">text</span>, <span class="ident">options</span>) <span class="op">=</span> <span class="ident">unfill</span>(<span class="string">&quot;\
* This is an
  example of
  a list item.
&quot;</span>);

<span class="macro">assert_eq!</span>(<span class="ident">text</span>, <span class="string">&quot;This is an example of a list item.\n&quot;</span>);
<span class="macro">assert_eq!</span>(<span class="ident">options</span>.<span class="ident">initial_indent</span>, <span class="string">&quot;* &quot;</span>);
<span class="macro">assert_eq!</span>(<span class="ident">options</span>.<span class="ident">subsequent_indent</span>, <span class="string">&quot;  &quot;</span>);</code></pre></div>
</div></details></section></div></main><div id="rustdoc-vars" data-root-path="../" data-current-crate="textwrap" data-themes="ayu,dark,light" data-resource-suffix="" data-rustdoc-version="1.64.0-dev" ></div>
</body></html>